function [E,G]=coutdiabflou1(param,X,q);

% function used by fuzzypca.m

[n,d]=size(X{1});

B = reshape(param,d,q);

%----------------------------------------------
% Propagation

Bplus=(B>0).*B;
Bmoins=B-Bplus;

E=0;
for l=1:4,
    Y{l}=X{l}*Bplus + X{4-l+1}*Bmoins;
end;
for l=1:4,
    Z{l}=Y{l}*Bplus' + Y{4-l+1}*Bmoins';
    E=E+0.25*sum(sum((X{l}-Z{l}).^2));
end;


%-----------------------------------------------
% Backpropagation

isBplus=(B>0);
isBmoins=(B<=0);
G=zeros(d,q);

for l=1:4,
    deltak{l} = 2*(Z{l}-X{l});
    dEdB2{l} = isBplus .* (deltak{l}'*Y{l}) + isBmoins .* (deltak{l}'*Y{4-l+1});  
    deltaj1{l} = deltak{l}*Bplus;
    deltaj2{l} = deltak{l}*Bmoins;
    dEdB1{l} = isBplus .* (X{l}'*deltaj1{l}) + isBmoins .* (X{4-l+1}'*deltaj1{l}) + ...
        isBplus .* (X{4-l+1}'*deltaj2{l}) + isBmoins .* (X{l}'*deltaj2{l});
    G=G+dEdB2{l}+dEdB1{l};
end;
G=0.25*G(:);
  



